------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Colors;
with Qt4.Icons;
with Qt4.Rects;
with Qt4.Sizes;
with Qt4.Strings;
with Qt4.Variants;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Tab_Bars is

   type Tab_Bar_Shape is
    (Rounded_North,
     Rounded_South,
     Rounded_West,
     Rounded_East,
     Triangular_North,
     Triangular_South,
     Triangular_West,
     Triangular_East);
   pragma Convention (C, Tab_Bar_Shape);

   type Q_Tab_Bar is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Tab_Bar_Access is
     access all Q_Tab_Bar'Class;
   for Q_Tab_Bar_Access'Storage_Size use 0;

   type Q_Tab_Bar_Pointer is tagged;

   function Add_Tab
    (Self : not null access Q_Tab_Bar'Class;
     Text : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Add_Tab
    (Self : not null access Q_Tab_Bar'Class;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Count
    (Self : not null access constant Q_Tab_Bar'Class)
       return Qt4.Q_Integer;

   function Current_Index
    (Self : not null access constant Q_Tab_Bar'Class)
       return Qt4.Q_Integer;

   function Draw_Base
    (Self : not null access constant Q_Tab_Bar'Class)
       return Standard.Boolean;

   function Icon_Size
    (Self : not null access constant Q_Tab_Bar'Class)
       return Qt4.Sizes.Q_Size;

   function Insert_Tab
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Insert_Tab
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Is_Tab_Enabled
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Standard.Boolean;

   procedure Remove_Tab
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer);

   procedure Set_Draw_Base
    (Self : not null access Q_Tab_Bar'Class;
     Draw_The_Base : Standard.Boolean);

   procedure Set_Icon_Size
    (Self : not null access Q_Tab_Bar'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Shape
    (Self : not null access Q_Tab_Bar'Class;
     Shape : Qt4.Tab_Bars.Tab_Bar_Shape);

   procedure Set_Tab_Data
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Data : Qt4.Variants.Q_Variant);

   procedure Set_Tab_Enabled
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Enabled : Standard.Boolean);

   procedure Set_Tab_Icon
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Icon : Qt4.Icons.Q_Icon);

   procedure Set_Tab_Text
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String);

   procedure Set_Tab_Text_Color
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Color : Qt4.Colors.Q_Color);

   procedure Set_Tab_Tool_Tip
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Tip : Qt4.Strings.Q_String);

   procedure Set_Tab_Whats_This
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String);

   procedure Set_Uses_Scroll_Buttons
    (Self : not null access Q_Tab_Bar'Class;
     Use_Buttons : Standard.Boolean);

   function Shape
    (Self : not null access constant Q_Tab_Bar'Class)
       return Qt4.Tab_Bars.Tab_Bar_Shape;

   function Tab_Data
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Variants.Q_Variant;

   function Tab_Icon
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Icons.Q_Icon;

   function Tab_Rect
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Rects.Q_Rect;

   function Tab_Text
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Tab_Text_Color
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Colors.Q_Color;

   function Tab_Tool_Tip
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Tab_Whats_This
    (Self : not null access constant Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Uses_Scroll_Buttons
    (Self : not null access constant Q_Tab_Bar'Class)
       return Standard.Boolean;

   procedure Set_Current_Index
    (Self : not null access Q_Tab_Bar'Class;
     Index : Qt4.Q_Integer);

   package Q_Tab_Bar_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Tab_Bar, Q_Tab_Bar_Access);

   type Q_Tab_Bar_Pointer is
     new Q_Tab_Bar_Pointers.Q_Pointer with null record;

end Qt4.Tab_Bars;
